import java.io.Serializable;

// *** Do you need to add an import statement here? ***

/**
 * Lab #6
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class models the Word ADT.
 * </P>
 * @author Group member names??
 * @version 1.0
 */
public class Word implements Comparable<Word>, Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** The name of the word represented by this class. */
	private String name;
	/** The language of origin of the word. */
	private String origin;
   
	/**
	 * This is the default constructor for the class Movie.
	 */   
	public Word() 
	{
		origin = "";
		name = "";
	}
   
	/**
	 * This is the constructor for the class Word. 
	 * It instantiates the class with user supplied values.
	 * <P>
	 * @param             name	     The name of the word.
	 * @param             origin      The language of origin of the word.
	 */   
	public Word(String name, String origin) 
	{
		this.name = new String( name );
		this.origin = origin;
	}
   
	/**
	 * Returns the name of the word.
	 * <P>
	 * @return            The name of the word as a string.
	 */      
	public String getName()
	{
		return name;
	}

	/**
	 * Sets the name of the word.
	 * <P>
	 * @param             name     The name of the word.
	 */      
	public void setName(String name)
	{
		this.name = name;
	}

	/**
	 * Returns the language of origin of the movie.
	 * <P>
	 * @return            The language of origin of the word.
	 */      
	public String getOrigin()
	{
		return origin;
	}

	/**
	 * Sets the language of origin.
	 * <P>
	 * @param             origin      The language of origin of the word.
	 */      
	public void setOrigin(String origin)
	{
		this.origin = origin;
	}

   /**
    * This method returns the attributes of this word as 
    * a single string.
    * </P>
    * @return            String representing the 
    *                    contents of this object.
    */
   public String toString()
   {
      return new String( "Name:  " + name + "   Origin: " + origin + "\n");
   }
    
   /**
    * This method compares an instance of Word with 
    * this instance of Word to see if they are equal.
    * <P>
    * Algorithm:<br>
    * Compare the name of the words.  If it is the same, 
    * then compare the language of origin.
    * </P>
    * @param             obj       The object we are comparing 
    *                              this instance of Word with.
    * @return            Returns true if the two instances are 
    *                    equal, false otherwise.
    */   
   public boolean equals( Object obj )
   {
      if( (obj instanceof Word) == false )
      {
    	  return false;
      }
      
      Word other = (Word)obj;

      // First compare the title of the movies.
      if( name.equals(other.name) == false)
      {
    	  return false;
      }

      // If the title is the same, handle the year.
      return origin == other.getOrigin();
   }
   
   /**
    * This method compares an instance of Word with 
    * this instance of Word to determine their relationship.
    * <P>
    * Algorithm:<br>
    * Compare the name of the words.  If it is the same, 
    * then compare the language of origin.
    * </P>
    * @param             other      The object we are comparing
    *                               this instance of Word with.
    * @return            Returns negative integer if this object is less then obj,
    *                    zero if the this object is equal to obj,
    *                    positive integer if this object is greater than obj.
    */    
   public int compareTo( Word other )
   {

      // First compare the title of the movies
      if( name.compareTo( other.getName() ) != 0 ) 
      {
    	  return name.compareTo( other.getName() );
      }

	  // If the name is the same, handle the origin.
	  return origin.compareTo(other.getOrigin());
      
  
      
   
   }
}
