import javax.swing.*;
import java.awt.event.*;
import java.awt.GridLayout;

/**
 * Lab #6
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class implements a dialog box that can be used
 * to input the data associated with a word.
 * </P>
 * @author Group member names??
 * @version 1.0
 */

public class WordDialog extends JDialog implements ActionListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** Data model for the dialog box. */
	private Word dataModel;
	/** Static constant that indicates the user clicked on "OK" */
	public static final int OK_OPTION = 1;
	/** Static constant that indicates the user clicked on "CANCEL" */
	public static final int CANCEL_OPTION = 0;
	/** Button for closing the dialog and saving changes. */
	JButton ok_button;
	/** Button for closing the dialog and not saving any changes. */
	JButton cancel_button;
	/** Indicates how the dialog was closed. */
	int close_option;
	
	/**
	 * Initializes the GUI for the dialog box.
	 * <P>
	 * @param   ownerFrame   Frame this dialog is to be attached to.
	 * @param   model        Data model to use for this dialog.
	 */
	WordDialog( JFrame ownerFrame, Word model )
	{

		/* Call the constructor of the super class (JDialog) and 
		 * to initialize the dialog object. */
		super( ownerFrame, true );


		/* Save a reference to the object serving as the data model
		 * for the dialog. */
		dataModel = model;
		
		
		/* Create components to add to the dialog and setup any necessary
		 * event listeners. */
		
		ok_button = new JButton("OK");
		cancel_button = new JButton("CANCEL");

		ok_button.addActionListener(this);
		cancel_button.addActionListener(this);
		
		// Change the layout manager
		getContentPane().setLayout(new GridLayout(0,2));
		
		/* Add the components to the content pane of the dialog. */

		getContentPane().add( ok_button );
		getContentPane().add( cancel_button );

		// Initialize the class variable that indicates how the dialog was closed.
		close_option = CANCEL_OPTION;

		// Resize the dialog so that it fit's it's contents.
		pack();
	}

	/**
	 * Returns a value indicating how the user closed the dialog.
	 * <P>
	 * @return  An integer indicating how the user closed the dialog
	 *          (will be either the constant OK_OPTION or CANCEL_OPTION.
	 */
	public int getCloseOption()
	{
		return close_option;
	}

	/**
	 * Method serving as the action event handler for the dialog.
	 * <P>
	 * @param  e  An instance of ActionEvent representing the event that
	 *            occurred.
	 */
	public void actionPerformed( ActionEvent e )
	{
		System.out.println(e);

		if(e.getSource()== ok_button)
		{
			close_option = OK_OPTION;
			dataModel.setName("Test");
			dataModel.setOrigin( "Swahili" );
		}
		
		if(e.getSource()== cancel_button)
		{
			close_option = CANCEL_OPTION;			
		}
		
		// Close the dialog.
		dispose();
	}
}
