import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Vector;

/**
 * Lab #6
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class implements a data type that represents
 * a list of words.
 * </P>
 * @author Group member names??
 * @version 1.0
 */
public class WordListModel
{
	/** List of words */
	private ArrayList<Word> wordList;

	/**
	 * Initializes the list model.
	 */
	WordListModel()
	{
		wordList = new ArrayList<Word>();
	}


	/**
	 * Adds a word to the list.
	 * <P>
	 * @param   word       Word to add to the list.
	 */
	public void add( Word word )
	{
		wordList.add( word );
	}

	/**
	 * Removes the specified word from the list.
	 * <P>
	 * @param    index   Index of the word in the list to remove.
	 */
	public void remove( int index )
	{
		wordList.remove( index );
	}

	/**
	 * Returns a vector representation of the list of words.
	 * <P>
	 * @return   A Vector containing the words in the list.
	 */
	public Vector<Word> getVector()
	{
		Vector<Word> wordVector = new Vector<Word>();
		wordVector.addAll( wordList );
		return wordVector;
	}

	/**
	 * Save the words to a file.
	 * <P>
	 * @param  filename     Name of the file to save the words to.
	 * @throws IOException  Thrown when <ecode>file<ecode> cannot
	 *                      be written to.
	 */
	public void saveToFile( String filename ) throws IOException
	{
		FileOutputStream fos = new FileOutputStream( filename );
		ObjectOutputStream oos = new ObjectOutputStream( fos );

		oos.writeObject( wordList );

		oos.close();
	}

	/**
	 * Load the words from a file.
	 * <P>
	 * @param  filename     Name of the file to load the words from.
	 * @throws IOException  Thrown when <ecode>file<ecode> cannot
	 *                      be written to.
	 * @throws ClassNotFoundException  Thrown when a class cannot
	 *                                 be read from the specified
	 *                                 file.
	 */
	public void loadFromFile( String filename ) 
	throws IOException, ClassNotFoundException
	{
		FileInputStream fis = new FileInputStream( filename );
		ObjectInputStream ois = new ObjectInputStream( fis );

		wordList = (ArrayList<Word>)ois.readObject();

		ois.close();  
	}

}

